



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python 爬取猫眼电影最受期待榜</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python 爬取猫眼电影最受期待榜</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 12:14:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　 &nbsp;主要爬取猫眼电影最受期待榜的电影排名、图片链接、名称、主演、上映时间。</p>
<p>　　思路：1.定义一个获取网页源代码的函数；</p>
<p>　　　　　2.定义一个解析网页源代码的函数；</p>
<p>　　　　　3.定义一个将解析的数据保存为本地文件的函数；</p>
<p>　　　　　4.定义主函数；</p>
<p>　　　　　5.使用多进程爬取。</p>
<p>步骤一：首先，导入相关的库：</p>
<div>
<pre class="prettyprint linenums">import requests<br />
import re<br />
import  json<br />
from multiprocessing import Pool<br />
from requests.exceptions import RequestException</pre>
</div>
<p>步骤二：定义获取网页源代码的函数，这里使用 requests.get() 方法来获取，并调用异常处理方法：</p>
<div>
<pre class="prettyprint linenums">def get_one_page(url):<br />
    response = requests.get(url)<br />
    try:<br />
        if response.status_code == 200:<br />
            return response.text<br />
        return None<br />
    except RequestException:<br />
        return None</pre>
</div>
<p>步骤三：定义一个函数，利用正则表达式 re.findall() 等函数解析网页源代码，并利用 yield 生成器对解析的代码进行排布，转换为字典形式：</p>
<div>
<pre class="prettyprint linenums">def parse_one_page(html):<br />
    pattern = re.compile('&lt;dd&gt;.*?board-index.*?"&gt;(\d+)&lt;/i&gt;.*?data-src="(.*?)".*?&lt;/a&gt;.*?'<br />
                         + '&lt;a.*?&gt;(.*?)&lt;/a&gt;.*?star"&gt;(.*?)&lt;/p&gt;.*?releasetime"&gt;(.*?)&lt;/p&gt;.*?&lt;/dd&gt;', re.S)<br />
    items = re.findall(pattern, html)<br />
    for item in items:<br />
        yield {<br />
            '排名': item[0],<br />
            '图片': item[1],<br />
            '名称': item[2],<br />
            '主演': item[3].strip()[3:],<br />
            '上映时间': item[4].strip()[5:]<br />
        }</pre>
</div>
<p>步骤四：定义主函数，爬取最受期待榜的 n 页：</p>
<div>
<pre class="prettyprint linenums">def main(offset):<br />
    url = 'https://maoyan.com/board/6?offset=' +str(offset)<br />
    html = get_one_page(url)<br />
    for item in parse_one_page(html):<br />
        print(item)<br />
        write_one_page(item)</pre>
</div>
<p>步骤五：多进程爬取，定义进程池，并调用 Pool.map() 方法进行多进程爬取，提高爬取效率：</p>
<div>
<pre class="prettyprint linenums">if __name__ == "__main__":<br />
    pool = Pool()<br />
    pool.map(main, [i*10 for i in range(10)])</pre>
</div>
<p>爬取的部分数据如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1110743/201708/1110743-20170813204600632-666560111.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jpvj49.html">GbkToUtf8 Utf8ToGbk PackHttp</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx5lo08.html">Ruby的基本语法-数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r61249.html">访问控制public&sol;protected&sol;private的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq476jeq.html">Android中将布局文件转成bitmap</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lrx49.html">Oracle 死锁的检测查询及处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvl46x8.html">MyBatis知多少（7）持久层</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zl3n69.html">Ibatis&comma;Spring整合（注解方式注入）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnopp6q.html">关于group by的一段SQl语句&mdash;&mdash;Oracle</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyy1z8.html">ZOJ1093 动态规划</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjv1438.html">mybatis逆向工程生成代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkrlgz8.html">alter 和 update的区别？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kdkxq.html">看完我身边前卫时尚女孩的手机 这几款APP强烈推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gew60l8.html">python学习日记（模块导入）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrkdm9.html">flash中调用XML遇到的中文显示异常问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2derz9.html">OpenStack 与 Rancher</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r17m39.html">关于loading</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j11o3q.html">zedboard上首个驱动实践&mdash;&mdash;Led</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw21xz9.html">C&plus;&plus;学习（七）（C语言部分）之 输入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyz26dq.html">C&plus;&plus;进阶--Koenig lookup 依赖于实参的名字查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv4lmxq.html">安卓开发 Activity入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj625g8.html">python全栈学习--day11&lpar;函数高级应用&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz6now8.html">&lbrack;开源&rsqb; yvm - 自制Java虚拟机</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj65lk8.html">听翁恺老师mooc笔记（3）--指针的定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m0e0j8.html">第一次作业：扑通扑通 我的IT</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp1zlxq.html">201621123050 《Java程序设计》第6周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m0yvn8.html">201621123068 作业07-Java GUI编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge6g308.html">Linux学习--线程概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd6gly9.html">使用Spark MLlib进行情感分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1n0d2q.html">nyoj 数的长度</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m0kzj8.html">kali rolling更新源之gpg和dirmngr问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
